/*
 * Created on Sep 19, 2004
 */
package org.tekkotsu.ui.editor.model.commands;

import org.eclipse.gef.commands.Command;
import org.tekkotsu.ui.editor.model.AbstractConnectionModel;
import org.tekkotsu.ui.editor.model.MultiTransitionModel;
import org.tekkotsu.ui.editor.model.SubConnectionModel;
import org.tekkotsu.ui.editor.model.LayoutData;

/**
 * @author asangpet
 */
public class DeleteConnectionCommand extends Command {
	private AbstractConnectionModel connection;
	private LayoutData layout;

	@Override
	public void execute() {
		layout.removeConnectionDescriptor(connection);
		
		if (connection.getParent() instanceof MultiTransitionModel) {
			MultiTransitionModel parent = (MultiTransitionModel) connection
					.getParent();

			for (SubConnectionModel sub : parent.getSubConnectionList()) {
				layout.removeConnectionDescriptor(sub);
				connection.detachSource();
				connection.detachTarget();
				layout.removeChild(sub);
				parent.removeSubConnection(sub);
			}
			// no more subconnection, remove multitransition node too
			layout.removeChild(parent);
		} else {
			connection.detachSource();
			connection.detachTarget();
			layout.removeChild(connection);
		}
	}

	public void setConnectionModel(Object model) {
		connection = (AbstractConnectionModel) model;
	}

	public void setContentsModel(Object model) {
		if (model instanceof LayoutData)
			layout = (LayoutData) model;
		else if (model instanceof MultiTransitionModel) {
			layout = (LayoutData) ((MultiTransitionModel) model)
					.getParent();
		}
	}

	@Override
	public void undo() {
		MultiTransitionModel parent = (MultiTransitionModel) connection
				.getParent();
		if (!layout.getPartChildren().contains(parent)) {
			layout.addChild(connection.getParent());
			parent.doPostAdd();
		}
		layout.addChild(connection);
		connection.attachSource();
		connection.attachTarget();
	}
}
