/*
 * Created on Apr 13, 2005
 */
package org.tekkotsu.ui.storyboard;

import org.eclipse.jface.resource.ColorRegistry;
import org.eclipse.jface.resource.ImageRegistry;
import org.eclipse.swt.widgets.Display;
import org.eclipse.ui.PlatformUI;

/**
 * 
 * @author asangpet
 */
public class ResourceRegistry {
    private Display display;
    private ImageRegistry imgReg;
    private ColorRegistry colReg;
    
    private static ResourceRegistry resourceReg = 
    	new ResourceRegistry();
    
    private ResourceRegistry() {
        display = PlatformUI.getWorkbench().getDisplay();
        imgReg = new ImageRegistry(display);
        colReg = new ColorRegistry(display);        
    }
    
    public static ResourceRegistry getInstance() {
        return resourceReg; 
    }
    
    public ImageRegistry getImageRegistry() {        
        return imgReg;
    }
    
    public Display getDisplay() {     
        return display;
    }
    
    public ColorRegistry getColorRegistry() {
        return colReg;
    }
}
